# Releases (2007)

Here is the list of official releases made during the year 2007. A similar list for 2006 is also available.

It is also possible to just use the GIT version or snapshot, contact the mailing list and check the GIT log to gauge progress.

### 0.4.0: Dec 18 2007

- Features:
  Compilation on Windows cygwin/mingw (Richard Jones),
  Ruby bindings (David Lutterkort),
  SASL based authentication for libvirt remote support (Daniel Berrange),
  PolicyKit authentication (Daniel Berrange)
- Documentation:
  example files for QEMU and libvirtd configuations (Daniel Berrange),
  english cleanups (Jim Paris),
  CIM and OpenVZ references,
  document <shareable/>,
  daemon startup when using QEMU/KVM,
  document HV support for new NUMA calls (Richard Jones),
  various english fixes (Bruce Montague),
  OCaml docs links (Richard Jones),
  describe the various bindings add Ruby link,
  Windows support page (Richard Jones),
  authentication documentation updates (Daniel Berrange)
- Bug Fixes:
  NUMA topology error handling (Beth Kon),
  NUMA topology cells without CPU (Beth Kon),
  XML to/from XM bridge config (Daniel Berrange),
  XM processing of vnc parameters (Daniel Berrange),
  Reset migration source after failure (Jim Paris),
  negative integer in config (Tatsuro Enokura),
  zero terminating string buffer,
  detect integer overflow (Jim Meyering),
  QEmu command line ending fixes (Daniel Berrange),
  recursion problem in the daemon (Daniel Berrange),
  HVM domain with CDRom (Masayuki Sunou),
  off by one error in NUMA cpu count (Beth Kon),
  avoid xend errors when adding disks (Masayuki Sunou),
  compile error (Chris Lalancette),
  transposed fwrite args (Jim Meyering),
  compile without xen and on solaris (Jim Paris),
  parsing of interface names (Richard Jones),
  overflow for starts on 32bits (Daniel Berrange),
  fix problems in error reporting (Saori Fukuta),
  wrong call to brSetForwardDelay changed to brSetEnableSTP (Richard Jones),
  allow shareable disk in old Xen,
  fix wrong certificate file (Jim Meyering),
  avoid some startup error when non-root,
  off-by-1 buffer NULL termination (Daniel Berrange),
  various string allocation fixes (Daniel Berrange),
  avoid problems with vnetXXX interfaces in domain dumps (Daniel Berrange),
  build fixes for RHEL (Daniel Berrange),
  virsh prompt should not depend on uid (Richard Jones),
  fix scaping of '<' (Richard Jones),
  fix detach-disk on Xen tap devices (Saori Fukuta),
  CPU parameter setting in XM config (Saori Fukuta),
  credential handling fixes (Daniel Berrange),
  fix compatibility with Xen 3.2.0 (Daniel Berrange)
- Improvements:
  /etc/libvirt/qemu.conf configuration for QEMU driver (Daniel Berrange),
  NUMA cpu pinning in config files (DV and Saori Fukuta),
  CDRom media change in KVM/QEMU (Daniel Berrange),
  tests for <shareable/> in configs,
  pinning inactive domains for Xen 3.0.3 (Saori Fukuta),
  use gnulib for portability enhancement (Jim Meyering),
  --without-libvirtd config option (Richard Jones),
  Python bindings for NUMA,
  add extra utility functions to buffer (Richard Jones),
  separate qparams module for handling query parameters (Richard Jones)
- Cleanups:
  remove virDomainRestart from API as it was never used (Richard Jones),
  constify params for attach/detach APIs (Daniel Berrange),
  gcc printf attribute checkings (Jim Meyering),
  refactoring of device parsing code and shell escaping (Daniel Berrange),
  virsh schedinfo parameters validation (Masayuki Sunou),
  Avoid risk of format string abuse (Jim Meyering),
  integer parsing cleanups (Jim Meyering),
  build out of the source tree (Jim Meyering),
  URI parsing refactoring (Richard Jones),
  failed strdup/malloc handling (Jim Meyering),
  Make "make distcheck" work (Jim Meyering),
  improve xen internall error reports (Richard Jones),
  cleanup of the daemon remote code (Daniel Berrange),
  rename error VIR_FROM_LINUX to VIR_FROM_STATS_LINUX (Richard Jones),
  don't compile the proxy if without Xen (Richard Jones),
  fix paths when configuring for /usr prefix,
  improve error reporting code (Jim Meyering),
  detect heap allocation failure (Jim Meyering),
  disable xen sexpr parsing code if Xen is disabled (Daniel Berrange),
  cleanup of the GetType entry point for Xen drivers,
  move some QEmu path handling to generic module (Daniel Berrange),
  many code cleanups related to the Windows port (Richard Jones),
  disable the proxy if using PolicyKit,
  readline availability detection,
  test libvirtd's config-processing code (Jim Meyering),
  use a variable name as sizeof argument (Jim Meyering)

### 0.3.3: Sep 30 2007

- Features:
  Avahi mDNS daemon export (Daniel Berrange),
  NUMA support (Beth Kan)
- Documentation:
  cleanups (Toth Istvan),
  typos (Eduardo Pereira)
- Bug Fixes:
  memory corruption on large dumps (Masayuki Sunou),
  fix virsh vncdisplay command exit (Masayuki Sunou),
  Fix network stats TX/RX result (Richard Jones),
  warning on Xen 3.0.3 (Richard Jones),
  missing buffer check in virDomainXMLDevID (Hugh Brock),
  avoid zombies when using remote (Daniel Berrange),
  xend connection error message (Richard Jones),
  avoid ssh tty prompt (Daniel Berrange),
  username handling for remote URIs (Fabian Deutsch),
  fix potential crash on multiple input XML tags (Daniel Berrange),
  Solaris Xen hypercalls fixup (Mark Johnson)
- Improvements:
  OpenVZ support (Shuveb Hussain and Anoop Cyriac),
  CD-Rom reload on XEn (Hugh Brock),
  PXE boot got QEmu/KVM (Daniel Berrange),
  QEmu socket permissions customization (Daniel Berrange),
  more QEmu support (Richard Jones),
  better path detection for qemu and dnsmasq (Richard Jones),
  QEmu flags are per-Domain (Daniel Berrange),
  virsh freecell command,
  Solaris portability fixes (Mark Johnson),
  default bootloader support (Daniel Berrange),
  new virNodeGetFreeMemory API,
  vncpasswd extraction in configuration files if secure (Mark Johnson and Daniel Berrange),
  Python bindings for block and interface statistics
- Cleanups:
  virDrvOpenRemoteFlags definition (Richard Jones),
  configure tests and output (Daniel Berrange)

### 0.3.2: Aug 21 2007

- Features:
  KVM migration and save/restore (Jim Paris),
  added API for migration (Richard Jones),
  added APIs for block device and interface statistic (Richard Jones)
- Documentation:
  examples for XML network APIs,
  fix typo and schedinfo synopsis in man page (Atsushi SAKAI),
  hypervisor support page update (Richard Jones)
- Bug Fixes:
  remove a couple of leaks in QEmu/KVM backend (Daniel berrange),
  fix GnuTLS 1.0 compatibility (Richard Jones),
  --config/-f option mistake for libvirtd (Richard Jones),
  remove leak in QEmu backend (Jim Paris),
  fix some QEmu communication bugs (Jim Paris),
  UUID lookup though proxy fix,
  setvcpus checking bugs (with Atsushi SAKAI),
  int checking in virsh parameters (with Masayuki Sunou),
  deny devices attach/detach for < Xen 3.0.4 (Masayuki Sunou),
  XenStore query memory leak (Masayuki Sunou),
  virsh schedinfo cleanup (Saori Fukuta)
- Improvements:
  virsh new ttyconsole command,
  networking API implementation for test driver (Daniel berrange),
  qemu/kvm feature reporting of ACPI/APIC (David Lutterkort),
  checking of QEmu architectures (Daniel berrange),
  improve devices XML errors reporting (Masayuki Sunou),
  speedup of domain queries on Xen (Daniel berrange),
  augment XML dumps with interface devices names (Richard Jones),
  internal API to query drivers for features (Richard Jones)
- Cleanups:
  Improve virNodeGetInfo implentation (Daniel berrange),
  general UUID code cleanup (Daniel berrange),
  fix API generator file selection

### 0.3.1: Jul 24 2007

- Documentation:
  index to remote page,
  script to test certificates,
  IPv6 remote support docs (Daniel Berrange),
  document VIRSH_DEFAULT_CONNECT_URI in virsh man page (David Lutterkort),
  Relax-NG early grammar for the network XML (David Lutterkort)
- Bug Fixes:
  leaks in disk XML parsing (Masayuki Sunou),
  hypervisor alignment call problems on PPC64 (Christian Ehrhardt),
  dead client registration in daemon event loop (Daniel Berrange),
  double free in error handling (Daniel Berrange),
  close on exec for log file descriptors in the daemon (Daniel Berrange),
  avoid caching problem in remote daemon (Daniel Berrange),
  avoid crash after QEmu domain failure (Daniel Berrange)
- Improvements:
  checks of x509 certificates and keys (Daniel Berrange),
  error reports in the daemon (Daniel Berrange),
  checking of Ethernet MAC addresses in XML configs (Masayuki Sunou),
  support for a new clock switch between UTC and localtime (Daniel Berrange),
  early version of OpenVZ support (Shuveb Hussain),
  support for input devices on PS/2 and USB buses (Daniel Berrange),
  more tests especially the QEmu support (Daniel Berrange),
  range check in credit scheduler (with Saori Fukuta and Atsushi Sakai),
  add support for listen VNC parameter un QEmu and fix command line arg (Daniel Berrange)
- Cleanups:
  debug tracing (Richard Jones),
  removal of --with-qemud-pid-file (Richard Jones),
  remove unused virDeviceMode,
  new util module for code shared between drivers (Shuveb Hussain),
  xen header location detection (Richard Jones)

### 0.3.0: Jul 09 2007

- Features:
  Secure Remote support (Richard Jones). See the remote page of the documentation
- Documentation:
  remote support (Richard Jones),
  description of the URI connection strings (Richard Jones),
  update of virsh man page,
  matrix of libvirt API/hypervisor support with version information (Richard Jones)
- Bug Fixes:
  examples Makefile.am generation (Richard Jones),
  SetMem fix (Mark Johnson),
  URI handling and ordering of drivers (Daniel Berrange),
  fix virsh help without hypervisor (Richard Jones),
  id marshalling fix (Daniel Berrange),
  fix virConnectGetMaxVcpus on remote (Richard Jones),
  avoid a realloc leak (Jim Meyering),
  scheduler parameters handling for Xen (Richard Jones),
  various early remote bug fixes (Richard Jones),
  remove virsh leaks of domains references (Masayuki Sunou),
  configCache refill bug (Richard Jones),
  fix XML serialization bugs
- Improvements:
  QEmu switch to XDR-based protocol (Dan Berrange),
  device attach/detach commands (Masayuki Sunou),
  OCaml bindings (Richard Jones),
  new entry points virDomainGetConnect and virNetworkGetConnect useful for bindings (Richard Jones),
  reunitifaction of remote and qemu daemon under a single libvirtd with a config file (Daniel Berrange),
  Localization updates
- Cleanups:
  parsing of connection URIs (Richard Jones),
  messages from virsh (Saori Fukuta),
  Coverage files (Daniel Berrange),
  Solaris fixes (Mark Johnson),
  avoid [r]index calls (Richard Jones),
  release information in Xen backend,
  virsh cpupin command cleanups (Masayuki Sunou),
  xen:/// support as standard Xen URI (Richard Jones and Daniel Berrange),
  improve driver selection/decline mechanism (Richard Jones),
  error reporting on XML dump (Richard Jones),
  Remove unused virDomainKernel structure (Richard Jones),
  daemon event loop event handling (Daniel Berrange),
  various unifications cleanup in the daemon merging (Daniel Berrange),
  internal file and timer monitoring API (Daniel Berrange),
  remove libsysfs dependancy,
  call brctl program directly (Daniel Berrange),
  virBuffer functions cleanups (Richard Jones),
  make init script LSB compliant,
  error handling on lookup functions (Richard Jones),
  remove internal virGetDomainByID (Richard Jones),
  revamp of xen subdrivers interfaces (Richard Jones)

### 0.2.3: Jun 08 2007

- Documentation:
  documentation for upcoming remote access (Richard Jones),
  virConnectNumOfDefinedDomains doc (Jan Michael),
  virsh help messages for dumpxml and net-dumpxml (Chris Wright)
- Bug Fixes:
  RelaxNG schemas regexp fix (Robin Green),
  RelaxNG arch bug (Mark McLoughlin),
  large buffers bug fixes (Shigeki Sakamoto),
  error on out of memory condition (Shigeki Sakamoto),
  virshStrdup fix,
  non-root driver when using Xen bug (Richard Jones),
  use --strict-order when running dnsmasq (Daniel Berrange),
  virbr0 weirdness on restart (Mark McLoughlin),
  keep connection error messages (Richard Jones),
  increase QEmu read buffer on help (Daniel Berrange),
  rpm dependance on dnsmasq (Daniel Berrange),
  fix XML boot device syntax (Daniel Berrange),
  QEmu memory bug (Daniel Berrange),
  memory leak fix (Masayuki Sunou),
  fix compiler flags (Richard Jones),
  remove type ioemu on recent Xen HVM for paravirt drivers (Saori Fukuta),
  uninitialized string bug (Masayuki Sunou),
  allow init even if the daemon is not running,
  XML to config fix (Daniel Berrange)
- Improvements:
  add a special error class for the test module (Richard Jones),
  virConnectGetCapabilities on proxy (Richard Jones),
  allow network driver to decline usage (Richard Jones),
  extend error messages for upcoming remote access (Richard Jones),
  on_reboot support for QEmu (Daniel Berrange),
  save daemon output in a log file (Daniel Berrange),
  xenXMDomainDefineXML can override guest config (Hugh Brock),
  add attach-device and detach-device commands to virsh (Masayuki Sunou and Mark McLoughlin and Richard Jones),
  make virGetVersion case insensitive and Python bindings (Richard Jones),
  new scheduler API (Atsushi SAKAI),
  localizations updates,
  add logging option for virsh (Nobuhiro Itou),
  allow arguments to be passed to bootloader (Hugh Brock),
  increase the test suite (Daniel Berrange and Hugh Brock)
- Cleanups:
  Remove VIR_DRV_OPEN_QUIET (Richard Jones),
  disable xm_internal.c for Xen > 3.0.3 (Daniel Berrange),
  unused fields in _virDomain (Richard Jones),
  export __virGetDomain and __virGetNetwork for libvirtd only (Richard Jones),
  ignore old VNC config for HVM on recent Xen (Daniel Berrange),
  various code cleanups,
  -Werror cleanup (Hugh Brock)

### 0.2.2: Apr 17 2007

- Documentation:
  fix errors due to Amaya (with Simon Hernandez),
  virsh uses kB not bytes (Atsushi SAKAI),
  add command line help to qemud (Richard Jones),
  xenUnifiedRegister docs (Atsushi SAKAI),
  strings typos (Nikolay Sivov),
  ilocalization problem raised by Thomas Canniot
- Bug Fixes:
  virsh memory values test (Masayuki Sunou),
  operations without libvirt_qemud (Atsushi SAKAI),
  fix spec file (Florian La Roche, Jeremy Katz, Michael Schwendt),
  direct hypervisor call (Atsushi SAKAI),
  buffer overflow on qemu networking command (Daniel Berrange),
  buffer overflow in quemud (Daniel Berrange),
  virsh vcpupin bug (Masayuki Sunou),
  host PAE detections and strcuctures size (Richard Jones),
  Xen PAE flag handling (Daniel Berrange),
  bridged config configuration (Daniel Berrange),
  erroneous XEN_V2_OP_SETMAXMEM value (Masayuki Sunou),
  memory free error (Mark McLoughlin),
  set VIR_CONNECT_RO on read-only connections (S.Sakamoto),
  avoid memory explosion bug (Daniel Berrange),
  integer overflow for qemu CPU time (Daniel Berrange),
  QEMU binary path check (Daniel Berrange)
- Cleanups:
  remove some global variables (Jim Meyering),
  printf-style functions checks (Jim Meyering),
  better virsh error messages,
  increase compiler checkings and security (Daniel Berrange),
  virBufferGrow usage and docs,
  use calloc instead of malloc/memset,
  replace all sprintf by snprintf,
  avoid configure clobbering user's CTAGS (Jim Meyering),
  signal handler error cleanup (Richard Jones),
  iptables internal code claenup (Mark McLoughlin),
  unified Xen driver (Richard Jones),
  cleanup XPath libxml2 calls,
  IPTables rules tightening (Daniel Berrange)
- Improvements:
  more regression tests on XML (Daniel Berrange),
  Python bindings now generate exception in error cases (Richard Jones),
  Python bindings for vir*GetAutoStart (Daniel Berrange),
  handling of CD-Rom device without device name (Nobuhiro Itou),
  fix hypervisor call to work with Xen 3.0.5 (Daniel Berrange),
  DomainGetOSType for inactive domains (Daniel Berrange),
  multiple boot devices for HVM (Daniel Berrange)

### 0.2.1: Mar 16 2007

- Features:
  Add support for network autostart and init scripts (Mark McLoughlin),
  New API virConnectGetCapabilities() to detect the virtualization capabilities of a host (Richard Jones)
- Documentation:
  Documentation updates especially on the XML formats
- Portability:
  IA64 fixes (Atsushi SAKAI),
  dependancies and build (Daniel Berrange),
  fix xend port detection (Daniel Berrange),
  icompile time warnings (Mark),
  avoid const related compiler warnings (Daniel Berrange),
  automated builds (Daniel Berrange),
  pointer/int mismatch (Richard Jones),
  configure time selection of drivers,
  libvirt spec hacking (Daniel Berrange)
- Bug Fixes:
  libvirt_qemud daemon path (Daniel Berrange),
  libvirt config directory (Daniel Berrange and Mark McLoughlin),
  memory leak in qemud (Mark),
  various fixes on network support (Mark),
  avoid Xen domain zombies on device hotplug errors (Daniel Berrange),
  various fixes on qemud (Mark),
  args parsing (Richard Jones),
  virsh -t argument (Saori Fukuta),
  avoid virsh crash on TAB key (Daniel Berrange),
  detect xend operation failures (Kazuki Mizushima),
  don't listen on null socket (Rich Jones),
  read-only socket cleanup (Rich Jones),
  use of vnc port 5900 (Nobuhiro Itou),
  assorted networking fixes (Daniel Berrange),
  shutoff and shutdown mismatches (Kazuki Mizushima),
  unlimited memory handling (Atsushi SAKAI),
  python binding fixes (Tatsuro Enokura)
- Improvements:
  qemud signal handling (Mark),
  don't shutdown or reboot domain0 (Kazuki Mizushima),
  QEmu version autodetection (Daniel Berrange),
  network UUIDs (Mark),
  speed up UUID domain lookups (Tatsuro Enokura and Daniel Berrange),
  support for paused QEmu CPU (Daniel Berrange),
  keymap VNC attribute support (Takahashi Tomohiro and Daniel Berrange),
  maximum number of virtual CPU (Masayuki Sunou),
  virtsh --readonly option (Rich Jones),
  python bindings for new functions (Daniel Berrange)
- Cleanups:
  Various internal cleanups (Richard Jones, Daniel Berrange, Mark McLoughlin)

### 0.2.0: Feb 14 2007

- Features:
  Add support for QEmu and KVM virtualization (Daniel Berrange),
  Add support for network configuration (Mark McLoughlin)
- Bug Fixes:
  avoid a crash in connect (Daniel Berrange),
  virsh args parsing (Richard Jones)
- Improvements:
  regression testing (Daniel Berrange),
  localization string updates
- Cleanups:
  Various internal cleanups (Mark McLoughlin, Richard Jones, Daniel Berrange, Karel Zak)

### 0.1.11: Jan 22 2007

- Features:
  Added a Relax-NG schemas to check XML instances
- Bug Fixes:
  Remove memory leak when freeing virConf objects
- Improvements:
  Finish XML <-> XM config files support,
  Finishing inactive domain support (Daniel Berrange)